#pragma once


#include <initguid.h>

// {58E5F134-B2AF-4813-B571-79B5EB4836AD}
DEFINE_GUID(CLSID_DS_CUDA_RENDERER, 
0x58e5f134, 0xb2af, 0x4813, 0xb5, 0x71, 0x79, 0xb5, 0xeb, 0x48, 0x36, 0xad);


const AMOVIESETUP_MEDIATYPE sudPinTypes = {
	&MEDIATYPE_Video,			// Major type
	&MEDIASUBTYPE_NULL			// Minor type
};

const AMOVIESETUP_PIN sudPins = {
	L"Input",					// Name of the pin (Obsolete)
	TRUE,						// Pin is rendered
	FALSE,						// Is not an output pin
	FALSE,						// Filter can not have zero instances of this pin
	FALSE,						// Filter can only have one instance of this pin
	&CLSID_NULL,				// Connects to filter (Obsolete)
	L"",						// Connects to pin	(Obsolete)
	1,							// Number of media types supported
	&sudPinTypes				// Details to pins
};

const AMOVIESETUP_FILTER sudSampVid = {
	&CLSID_DS_CUDA_RENDERER,		// Class identifier of the filter
	L"DS_CUDA_RENDERER",		// Name of the filter
	MERIT_UNLIKELY,				// Filter merit
	1,							// Number of pins
	&sudPins					// Pin details
};


CFactoryTemplate g_Templates[] = {
	{	L"DS_CUDA_RENDERER",			// Name of the filter
		&CLSID_DS_CUDA_RENDERER,			// Pointer to the CLSID of the object
		CUDA_VideoRenderer::CreateInstance,	// Pointer to a function that creates
										// an instance of the object
		NULL,							// Pointer to a function that gets called
										// from the DLL entry point
		&sudSampVid }					// Pointer to a structure which specifies the filter
};

int g_cTemplates = sizeof(g_Templates)/sizeof(g_Templates[0]);